<?php
class FileIterator implements Iterator {
    private $filename,
            $handle,
            $current_key,
            $current_line;

    public function __construct($filename) {
        $this->filename = $filename;
    }

    public function key() {
        return $this->current_key;
    }

    public function current() {
        return $this->current_value;
    }

    public function next() {
        $this->current_key++;
        $this->current_value = fgets($this->handle);
    }

    public function rewind() {
        if ($this->handle !== null) {
            fclose($this->handle);
        }

        $this->handle = fopen($this->filename, 'r');
        $this->current_key = 1;
        $this->current_value = fgets($this->handle);
    }

    public function valid() {
        return !feof($this->handle);
    }

    public function __destruct() {
        fclose($this->handle);
    }
}

$f = new FileIterator('file');
foreach ($f as $line) {
    echo $line;
}